using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_Maestros._0_Modelos;
using System.Transactions;
using System.Data.SqlClient;
using static Exferia_Aplicacion.General.Enumerados;
using System.Threading;

namespace Exferia_Maestros._1_Datos
{
    public class MAE_Soportes_Datos : ABS_Datos
    {
        #region Listado
        private List<INTERNO_MAE_Soportes_Listado_Modelo> g_lst_INTERNO_MAE_Soportes_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_MAE = null;
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_Soportes).Name), _lst_CamposConRelacionABuscar, -1, null,_lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if((g_lst_INTERNO_MAE_Soportes_Listado_Modelo != null ) && (g_lst_INTERNO_MAE_Soportes_Listado_Modelo.Count() > 0))
                {
                    lst_MAE = g_lst_INTERNO_MAE_Soportes_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Soportes_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_MAE;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_Soportes).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_MAE_Soportes_Listado_Modelo != null) && (g_lst_INTERNO_MAE_Soportes_Listado_Modelo.Count() > 0))
                {
                    dnm_MAE = g_lst_INTERNO_MAE_Soportes_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Vendedores_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idEmpresasRelacionadas);

                //Filtros de Opciones ............................................................
                long lng_Padre_id_Empresa = -1;
                string str_Padre_Opcion_Empresa = "";

                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    foreach (INTERNO_Filtro_OpcionPadre_Modelo mdl_INTERNO_Filtro_OpcionPadre_Modelo in _lst_INTERNO_Filtro_OpcionPadre_Modelo)
                    {
                        //Empresa
                        if (mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO.Equals(Variables.G_STR_OPCION_GEN_EMPRESA))
                        {
                            lng_Padre_id_Empresa = mdl_INTERNO_Filtro_OpcionPadre_Modelo.VALOR;
                            str_Padre_Opcion_Empresa = mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO;
                        }
                    }
                }
                //..............................................................................

                string str_SQL =
                      " SELECT " +
                          nameof(INTERNO_MAE_Soportes_Listado_Modelo.id) + " = " + nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.id) + "," +
                          nameof(INTERNO_MAE_Soportes_Listado_Modelo.codigo) + " = " + nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.codigo) + "," +
                          nameof(INTERNO_MAE_Soportes_Listado_Modelo.descripcion) + " = " + nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.descripcion) + "," +
                          nameof(INTERNO_MAE_Soportes_Listado_Modelo.medida_Alto) + " = " + nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.medida_Alto) + "," +
                          nameof(INTERNO_MAE_Soportes_Listado_Modelo.medida_Ancho) + " = " + nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.medida_Ancho) + "," +
                          nameof(INTERNO_MAE_Soportes_Listado_Modelo.medida_Largo) + " = " + nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.medida_Largo) + "," +
                          //ids
                          nameof(INTERNO_MAE_Soportes_Listado_Modelo.idEmpresa) + " = " + nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.idEmpresa) + "," +
                          nameof(INTERNO_MAE_Soportes_Listado_Modelo.idUbicacionPerfil) + " = " + nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.idUbicacionPerfil) + "," +
                          //Empresa
                          (
                            (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_MAE_Soportes_Listado_Modelo.Empresa)))
                              ?
                                  (
                                      nameof(INTERNO_MAE_Soportes_Listado_Modelo.Empresa_Codigo) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.codigo) + "," +
                                      nameof(INTERNO_MAE_Soportes_Listado_Modelo.Empresa_Descripcion) + " =" + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.descripcion) + "," +
                                      nameof(INTERNO_MAE_Soportes_Listado_Modelo.Empresa_FechaBorrado) + " =" + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.fechaBorrado) + ","
                                  )
                              :
                                  (
                                      nameof(INTERNO_MAE_Soportes_Listado_Modelo.Empresa_Codigo) + " = ''," +
                                      nameof(INTERNO_MAE_Soportes_Listado_Modelo.Empresa_Descripcion) + " = ''," +
                                      nameof(INTERNO_MAE_Soportes_Listado_Modelo.Empresa_FechaBorrado) + " = NULL, "
                                  )
                          ) +
                          //UbicacionPerfil
                          (
                            (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_MAE_Soportes_Listado_Modelo.UbicacionPerfil)))
                              ?
                                  (
                                      nameof(INTERNO_MAE_Soportes_Listado_Modelo.UbicacionPerfil_Codigo) + " = " + nameof(MAE_UbicacionesPerfiles) + "." + nameof(MAE_UbicacionesPerfiles.codigo) + "," +
                                      nameof(INTERNO_MAE_Soportes_Listado_Modelo.UbicacionPerfil_Descripcion) + " =" + nameof(MAE_UbicacionesPerfiles) + "." + nameof(MAE_UbicacionesPerfiles.descripcion) + "," +
                                      nameof(INTERNO_MAE_Soportes_Listado_Modelo.UbicacionPerfil_FechaBorrado) + " =" + nameof(MAE_UbicacionesPerfiles) + "." + nameof(MAE_UbicacionesPerfiles.fechaBorrado) 
                                  )
                              :
                                  (
                                      nameof(INTERNO_MAE_Soportes_Listado_Modelo.UbicacionPerfil_Codigo) + " = ''," +
                                      nameof(INTERNO_MAE_Soportes_Listado_Modelo.UbicacionPerfil_Descripcion) + " = ''," +
                                      nameof(INTERNO_MAE_Soportes_Listado_Modelo.UbicacionPerfil_FechaBorrado) + " = NULL "
                                  )
                          ) +
                       " FROM " + nameof(MAE_Soportes) +
                          //Empresa
                          (
                               (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_MAE_Soportes_Listado_Modelo.Empresa)))
                                  ?
                                      (
                                       " LEFT JOIN " + nameof(GEN_Empresas) + " ON " + nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.idEmpresa) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.id)
                                      )
                                  : ("")
                          ) +
                          //UbicacionPerfil
                          (
                               (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_MAE_Soportes_Listado_Modelo.UbicacionPerfil)))
                                  ?
                                      (
                                       " LEFT JOIN " + nameof(MAE_UbicacionesPerfiles) + " ON " + nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.idUbicacionPerfil) + " = " + nameof(MAE_UbicacionesPerfiles) + "." + nameof(MAE_UbicacionesPerfiles.id)
                                       )
                                  : ("")
                          ) +
                       " WHERE " + nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.fechaBorrado) + " IS null AND " +
                            " ( " + nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.idEmpresa) + "=@idEmpresa" +
                                (
                                    (_lst_idEmpresasRelacionadas != null && _lst_idEmpresasRelacionadas.Count > 0)
                                        ? (" OR " + nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.idEmpresa) + " in (" + str_Filtros_Empresas + ") ")
                                        : " "
                                ) +
                            " ) AND " +
                            (_lng_id > -1 ? nameof(MAE_Soportes) + "." + (nameof(MAE_Soportes.id) + "=@id") : "1 = 1") + " AND " +
                            //Filtro por datos del padre relacionado Empresa
                            (
                                !str_Padre_Opcion_Empresa.Equals("")
                                    //Empresa
                                    ? str_Padre_Opcion_Empresa.Equals(Variables.G_STR_OPCION_GEN_EMPRESA)
                                        ? (nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.idEmpresa) + "=@id_Padre_Empresa")
                                        : ("1 = 1")
                                    : ("1 = 1")
                            );

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresaSeleccionada));
                lst_Parametros.Add(new SqlParameter("@id", _lng_id));
                lst_Parametros.Add(new SqlParameter("@id_Padre_Empresa", lng_Padre_id_Empresa));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                g_lst_INTERNO_MAE_Soportes_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_MAE_Soportes_Listado_Modelo>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Soportes_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        private INTERNO_MAE_Soportes_Listado_Modelo g_mdl_INTERNO_MAE_Soportes_Listado_Modelo_F3= null;

        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_Soportes).Name), _str_CampoBusqueda, _str_filtro, -1, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_MAE_Soportes_Listado_Modelo_F3 != null)
                {
                    dnm_MAE = g_mdl_INTERNO_MAE_Soportes_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Soportes_Datos) + "/" + nameof(Obtener_F3),true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_Soportes).Name), "", "", _lng_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................
                
                if(g_mdl_INTERNO_MAE_Soportes_Listado_Modelo_F3 != null)
                {
                    dnm_MAE = g_mdl_INTERNO_MAE_Soportes_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Soportes_Datos) + "/" + nameof(Obtener_F3_PorId), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idEmpresasRelacionadas);

                //Filtros de Opciones ............................................................
                long lng_Padre_id_Empresa = -1;
                string str_Padre_Opcion_Empresa = "";

                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    foreach (INTERNO_Filtro_OpcionPadre_Modelo mdl_INTERNO_Filtro_OpcionPadre_Modelo in _lst_INTERNO_Filtro_OpcionPadre_Modelo)
                    {
                        //Empresa
                        if (mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO.Equals(Variables.G_STR_OPCION_GEN_EMPRESA))
                        {
                            lng_Padre_id_Empresa = mdl_INTERNO_Filtro_OpcionPadre_Modelo.VALOR;
                            str_Padre_Opcion_Empresa = mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO;
                        }
                    }
                }
                //..............................................................................

                string str_SQL =
                     " SELECT distinct " +
                         nameof(INTERNO_MAE_Soportes_Listado_Modelo.id) + " = " + nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.id) + "," +
                         nameof(INTERNO_MAE_Soportes_Listado_Modelo.codigo) + " = " + nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.codigo) + "," +
                         nameof(INTERNO_MAE_Soportes_Listado_Modelo.descripcion) + " = " + nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.descripcion) +
                     " FROM " + nameof(MAE_Soportes) +
                     " WHERE " + nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.fechaBorrado) + " IS null AND " +
                           " ( " + nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.idEmpresa) + "=@idEmpresa" +
                                (
                                    (_lst_idEmpresasRelacionadas != null && _lst_idEmpresasRelacionadas.Count > 0)
                                        ? (" OR " + nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.idEmpresa) + " in (" + str_Filtros_Empresas + ") ")
                                        : " "
                                ) +
                            " ) AND " +
                          (
                           (_lng_id > -1)
                             ? (nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.id) + " = " + _lng_id)
                             : (
                                  //Filtrar por Codigo
                                  (_str_CampoBusqueda.Equals(nameof(MAE_Soportes.codigo)))
                                      ? (nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.codigo) + "=@Filtro")
                                      //Filtrar por Descripcion
                                      : (nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.descripcion) + "=@Filtro")
                               )
                          )
                           + " AND " +
                            //Filtro por datos del padre relacionado Empresa
                            (
                                !str_Padre_Opcion_Empresa.Equals("")
                                    //Empresa
                                    ? str_Padre_Opcion_Empresa.Equals(Variables.G_STR_OPCION_GEN_EMPRESA)
                                        ? (nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.idEmpresa) + "=@id_Padre_Empresa")
                                        : ("1 = 1")
                                    : ("1 = 1")
                            );

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresaSeleccionada));
                lst_Parametros.Add(new SqlParameter("@Filtro", _str_Filtro));
                lst_Parametros.Add(new SqlParameter("@id_Padre_Empresa", lng_Padre_id_Empresa));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                g_mdl_INTERNO_MAE_Soportes_Listado_Modelo_F3 = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_MAE_Soportes_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Soportes_Datos) + "/" + nameof(ConsultaRellenar_F3), true);
            }
        }
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 2;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                 " SELECT " +
                        nameof(MAE_Soportes.id) + "," +
                        nameof(MAE_Soportes.codigo) + "," +
                        nameof(MAE_Soportes.descripcion) + "," +
                        nameof(MAE_Soportes.medida_Alto) + "," +
                        nameof(MAE_Soportes.medida_Ancho) + "," +
                        nameof(MAE_Soportes.medida_Largo) + "," +
                        nameof(MAE_Soportes.idEmpresa) + "," +
                        nameof(MAE_Soportes.idUbicacionPerfil) + "," +
                        nameof(MAE_Soportes.fechaBorrado) +
                 " FROM " + nameof(MAE_Soportes) +
                 " WHERE " + nameof(MAE_Soportes.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<MAE_Soportes>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //GEN_Empresas ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idEmpresa != null)
                    {
                        ThreadStart obj_ThreadStart_EMPRESA = new ThreadStart(Obtener_Empresa_Modelo_Obtener);
                        Thread obj_Thread_EMPRESA = new Thread(obj_ThreadStart_EMPRESA);
                        obj_Thread_EMPRESA.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[0] = true;
                    }

                    //MAE_UbicacionesPerfiles ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idUbicacionPerfil != null)
                    {
                        ThreadStart obj_ThreadStart_UBICACIONPERFIL = new ThreadStart(Obtener_UbicacionPerfil_Modelo_Obtener);
                        Thread obj_Thread_UBICACIONPERFIL = new Thread(obj_ThreadStart_UBICACIONPERFIL);
                        obj_Thread_UBICACIONPERFIL.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[1] = true;
                    }

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Soportes_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }

        #region Tablas Relacionadas
        private void Obtener_Empresa_Modelo_Obtener()
        {
            try
            {
                g_dnm_Modelo_Obtener.GEN_Empresas = Datos_Generales.GEN_Empresas_Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idEmpresa);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        private void Obtener_UbicacionPerfil_Modelo_Obtener()
        {
            try
            {
                MAE_UbicacionesPerfiles_Datos obj_MAE_UbicacionesPerfiles_Datos = new MAE_UbicacionesPerfiles_Datos();
                g_dnm_Modelo_Obtener.MAE_UbicacionesPerfiles = obj_MAE_UbicacionesPerfiles_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idUbicacionPerfil,true);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[1] = true;
            }
        }
        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private MAE_Soportes g_mdl_MAE_Soportes = null;
        public MAE_Soportes Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(MAE_Soportes) + "." + nameof(MAE_Soportes.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Soportes_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_MAE_Soportes;
        }
        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                               object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_mdl_MAE_Soportes = obj_Exferia_Entities.Database.SqlQuery<MAE_Soportes>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Soportes_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #region Modelo Listado
        private List<MAE_Soportes> g_lst_MAE_Soportes = null;

        public List<MAE_Soportes> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids)
        {
            try
            {
                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {
                    string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(MAE_Soportes),
                                                                                            nameof(MAE_Soportes.id),
                                                                                            G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                            _lst_Ids);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                                " WHERE " +
                                                    str_Filtro_IDS;

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { });
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Soportes_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_MAE_Soportes;
        }

        #region Ejecutar Consulta

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                      object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_MAE_Soportes = obj_Exferia_Entities.Database.SqlQuery<MAE_Soportes>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Soportes_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                        nameof(MAE_Soportes.id) + "," +
                        nameof(MAE_Soportes.codigo) + "," +
                        nameof(MAE_Soportes.descripcion) + "," +
                        nameof(MAE_Soportes.medida_Alto) + "," +
                        nameof(MAE_Soportes.medida_Ancho) + "," +
                        nameof(MAE_Soportes.medida_Largo) + "," +
                        nameof(MAE_Soportes.idEmpresa) + "," +
                        nameof(MAE_Soportes.idUbicacionPerfil) + "," +
                        nameof(MAE_Soportes.fechaBorrado) +
                " FROM " + nameof(MAE_Soportes);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;
            
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                MAE_Soportes mdl_MAE_Soportes_AGrabar = (MAE_Soportes)_mdl_obj;
                MAE_Soportes mdl_MAE_Soportes_DatosViejos = new MAE_Soportes();

                // Ver si existe ######################################################################
                MAE_Soportes mdl_MAE_Soportes_Final = Obtener_Modelo_Por_Id(mdl_MAE_Soportes_AGrabar.id);
                //#####################################################################################

                //UPDATE
                if (mdl_MAE_Soportes_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos Viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_Soportes_Final, mdl_MAE_Soportes_DatosViejos, false, false);

                    //Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_Soportes_AGrabar, mdl_MAE_Soportes_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(MAE_Soportes) +
                                            " SET " +
                                                nameof(MAE_Soportes.codigo) + "=@codigo," +
                                                nameof(MAE_Soportes.descripcion) + "=@descripcion," +
                                                nameof(MAE_Soportes.medida_Alto) + "=@medida_Alto," +
                                                nameof(MAE_Soportes.medida_Ancho) + "=@medida_Ancho," +
                                                nameof(MAE_Soportes.medida_Largo) + "=@medida_Largo," +
                                                nameof(MAE_Soportes.idEmpresa) + "=@idEmpresa," +
                                                nameof(MAE_Soportes.idUbicacionPerfil) + "=@idUbicacionPerfil," +
                                                nameof(MAE_Soportes.fechaBorrado) + "=@fechaBorrado"+
                                            " WHERE " +
                                                nameof(MAE_Soportes.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@codigo", mdl_MAE_Soportes_Final.codigo),
                        new SqlParameter("@descripcion", mdl_MAE_Soportes_Final.descripcion),
                        new SqlParameter("@idEmpresa", mdl_MAE_Soportes_Final.idEmpresa),
                        mdl_MAE_Soportes_Final.medida_Alto != null
                            ?   new SqlParameter("@medida_Alto", mdl_MAE_Soportes_Final.medida_Alto.Value)
                            :   new SqlParameter("@medida_Alto",  DBNull.Value),
                        mdl_MAE_Soportes_Final.medida_Ancho != null
                            ?   new SqlParameter("@medida_Ancho", mdl_MAE_Soportes_Final.medida_Ancho.Value)
                            :   new SqlParameter("@medida_Ancho",  DBNull.Value),
                        mdl_MAE_Soportes_Final.medida_Largo != null
                            ?   new SqlParameter("@medida_Largo", mdl_MAE_Soportes_Final.medida_Largo.Value)
                            :   new SqlParameter("@medida_Largo",  DBNull.Value),
                        new SqlParameter("@idUbicacionPerfil", mdl_MAE_Soportes_Final.idUbicacionPerfil),
                        mdl_MAE_Soportes_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_MAE_Soportes_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        new SqlParameter("@id", mdl_MAE_Soportes_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_MAE_Soportes_Final.id;
                }
                ///INSERT
                else
                {
                    mdl_MAE_Soportes_Final = new MAE_Soportes();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos Del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_Soportes_AGrabar, mdl_MAE_Soportes_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(MAE_Soportes) +
                                                " (" +
                                                      nameof(MAE_Soportes.codigo) + "," +
                                                      nameof(MAE_Soportes.descripcion) + "," +
                                                      nameof(MAE_Soportes.medida_Alto) + "," +
                                                      nameof(MAE_Soportes.medida_Ancho) + "," +
                                                      nameof(MAE_Soportes.medida_Largo) + "," +
                                                      nameof(MAE_Soportes.idEmpresa) + "," +
                                                      nameof(MAE_Soportes.idUbicacionPerfil) + "," +
                                                      nameof(MAE_Soportes.fechaBorrado) +
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(MAE_Soportes.id) +
                                                " VALUES " +
                                                " ( " +
                                                    "@codigo," +
                                                    "@descripcion," +
                                                    "@medida_Alto," +
                                                    "@medida_Ancho," +
                                                    "@medida_Largo," +
                                                    "@idEmpresa," +
                                                    "@idUbicacionPerfil," +
                                                    "@fechaBorrado" +
                                                " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@codigo", mdl_MAE_Soportes_Final.codigo),
                        new SqlParameter("@descripcion", mdl_MAE_Soportes_Final.descripcion),
                        new SqlParameter("@idEmpresa", mdl_MAE_Soportes_Final.idEmpresa),
                        mdl_MAE_Soportes_Final.medida_Alto != null
                            ?   new SqlParameter("@medida_Alto", mdl_MAE_Soportes_Final.medida_Alto.Value)
                            :   new SqlParameter("@medida_Alto",  DBNull.Value),
                        mdl_MAE_Soportes_Final.medida_Ancho != null
                            ?   new SqlParameter("@medida_Ancho", mdl_MAE_Soportes_Final.medida_Ancho.Value)
                            :   new SqlParameter("@medida_Ancho",  DBNull.Value),
                        mdl_MAE_Soportes_Final.medida_Largo != null
                            ?   new SqlParameter("@medida_Largo", mdl_MAE_Soportes_Final.medida_Largo.Value)
                            :   new SqlParameter("@medida_Largo",  DBNull.Value),
                        new SqlParameter("@idUbicacionPerfil", mdl_MAE_Soportes_Final.idUbicacionPerfil),
                        mdl_MAE_Soportes_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_MAE_Soportes_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                //Grabar un registro de trazabilidad con los datos de la transaccion ralizada
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(MAE_Soportes), mdl_MAE_Soportes_DatosViejos, mdl_MAE_Soportes_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Soportes_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;
            
            try
            {

                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                MAE_Soportes mdl_MAE_Soportes_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_MAE_Soportes_Final != null)
                {
                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(MAE_Soportes) +
                                                " SET " +
                                                nameof(MAE_Soportes.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(MAE_Soportes.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                                 new SqlParameter("@fechaBorrado",  DateTime.Now),
                                new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(MAE_Soportes), null, mdl_MAE_Soportes_Final, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                //Devolver tambien el objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Soportes_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }
        #endregion
    }
}
